Support
API ReferencePlatform & IntegrationANS API

Certificate Management

View as Markdown

Retrieve agent identity certificates

GET
/v1/agents/{agentId}/certificates/identity

Path Parameters

agentId*string

Unique identifier of the agent (UUID format)

Response Body

application/json

application/json

application/json

application/json

application/json

curl -X GET "https://api.godaddy.com/v1/agents/string/certificates/identity"
[
  {
    "certificateIssuer": "CN=Agent Name Service CA,O=GoDaddy,C=US",
    "certificatePEM": "-----BEGIN CERTIFICATE-----\nCERT DATA\n...truncated...\n-----END CERTIFICATE-----",
    "certificatePublicKeyAlgorithm": "RSA",
    "certificateSerialNumber": "1234567890ABCDEF",
    "certificateSignatureAlgorithm": "SHA256withRSA",
    "certificateSubject": "CN=myagent.example.com,O=Example Corp,C=US,SAN:URI:ans://v1.0.0.myagent.example.com",
    "certificateValidFrom": "2019-08-24T14:15:22Z",
    "certificateValidTo": "2019-08-24T14:15:22Z",
    "chainPEM": "string",
    "csrId": "3081018b-0577-442d-b092-6e1f08ef6e0d"
  }
]
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}

Submit identity certificate CSR

POST
/v1/agents/{agentId}/certificates/identity

Path Parameters

agentId*string

Unique identifier of the agent (UUID format)

Request Body

application/json

CSR submission request

csrPEM*string

Base64 encoded PEM Certificate Signing Request

Response Body

application/json

application/json

application/json

application/json

application/json

application/json

curl -X POST "https://api.godaddy.com/v1/agents/string/certificates/identity" \  -H "Content-Type: application/json" \  -d '{    "csrPEM": "string"  }'
{
  "csrId": "3081018b-0577-442d-b092-6e1f08ef6e0d",
  "message": "string"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}

Retrieve agent server certificates

GET
/v1/agents/{agentId}/certificates/server

Path Parameters

agentId*string

Unique identifier of the agent (UUID format)

Response Body

application/json

application/json

application/json

application/json

application/json

curl -X GET "https://api.godaddy.com/v1/agents/string/certificates/server"
[
  {
    "certificateIssuer": "CN=Agent Name Service CA,O=GoDaddy,C=US",
    "certificatePEM": "-----BEGIN CERTIFICATE-----\nCERT DATA\n...truncated...\n-----END CERTIFICATE-----",
    "certificatePublicKeyAlgorithm": "RSA",
    "certificateSerialNumber": "1234567890ABCDEF",
    "certificateSignatureAlgorithm": "SHA256withRSA",
    "certificateSubject": "CN=myagent.example.com,O=Example Corp,C=US,SAN:URI:ans://v1.0.0.myagent.example.com",
    "certificateValidFrom": "2019-08-24T14:15:22Z",
    "certificateValidTo": "2019-08-24T14:15:22Z",
    "chainPEM": "string",
    "csrId": "3081018b-0577-442d-b092-6e1f08ef6e0d"
  }
]
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}

Retrieve pending renewal status

GET
/v1/agents/{agentId}/certificates/server/renewal

Path Parameters

agentId*string

Unique identifier of the agent (UUID format)

Response Body

application/json

application/json

application/json

application/json

application/json

curl -X GET "https://api.godaddy.com/v1/agents/string/certificates/server/renewal"
{
  "renewalType": "SERVER_CSR",
  "status": "PENDING_VALIDATION",
  "csrId": "3081018b-0577-442d-b092-6e1f08ef6e0d",
  "challenges": {
    "dns01": {
      "dnsRecord": {
        "name": "_acme-challenge.agent.example.com",
        "type": "TXT",
        "value": "string"
      },
      "expiresAt": "2019-08-24T14:15:22Z",
      "httpPath": "/.well-known/acme-challenge/xyz123",
      "keyAuthorization": "string",
      "token": "string",
      "type": "DNS_01"
    },
    "http01": {
      "dnsRecord": {
        "name": "_acme-challenge.agent.example.com",
        "type": "TXT",
        "value": "string"
      },
      "expiresAt": "2019-08-24T14:15:22Z",
      "httpPath": "/.well-known/acme-challenge/xyz123",
      "keyAuthorization": "string",
      "token": "string",
      "type": "DNS_01"
    }
  },
  "tlsaDnsRecord": {
    "name": "string",
    "priority": 0,
    "purpose": "DISCOVERY",
    "required": true,
    "ttl": 3600,
    "type": "HTTPS",
    "value": "string"
  },
  "failureReason": "string",
  "expiresAt": "2019-08-24T14:15:22Z",
  "nextStep": {
    "action": "CONFIGURE_DNS",
    "description": "string",
    "endpoint": "http://example.com"
  }
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}

Submit server certificate renewal request

POST
/v1/agents/{agentId}/certificates/server/renewal

Path Parameters

agentId*string

Unique identifier of the agent (UUID format)

Request Body

application/json

Renewal request (CSR or BYOC)

Response Body

application/json

application/json

application/json

application/json

application/json

application/json

application/json

curl -X POST "https://api.godaddy.com/v1/agents/string/certificates/server/renewal" \  -H "Content-Type: application/json" \  -d '{}'
{
  "renewalType": "SERVER_CSR",
  "status": "PENDING_VALIDATION",
  "csrId": "3081018b-0577-442d-b092-6e1f08ef6e0d",
  "challenges": {
    "dns01": {
      "dnsRecord": {
        "name": "_acme-challenge.agent.example.com",
        "type": "TXT",
        "value": "string"
      },
      "expiresAt": "2019-08-24T14:15:22Z",
      "httpPath": "/.well-known/acme-challenge/xyz123",
      "keyAuthorization": "string",
      "token": "string",
      "type": "DNS_01"
    },
    "http01": {
      "dnsRecord": {
        "name": "_acme-challenge.agent.example.com",
        "type": "TXT",
        "value": "string"
      },
      "expiresAt": "2019-08-24T14:15:22Z",
      "httpPath": "/.well-known/acme-challenge/xyz123",
      "keyAuthorization": "string",
      "token": "string",
      "type": "DNS_01"
    }
  },
  "expiresAt": "2019-08-24T14:15:22Z",
  "nextStep": {
    "action": "CONFIGURE_DNS",
    "description": "string",
    "endpoint": "http://example.com"
  },
  "links": [
    {
      "href": "https://api.godaddy.com/v1/agents/550e8400-e29b-41d4-a716-446655440000",
      "rel": "agent-details"
    }
  ]
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}

Cancel pending renewal

DELETE
/v1/agents/{agentId}/certificates/server/renewal

Path Parameters

agentId*string

Unique identifier of the agent (UUID format)

Response Body

application/json

application/json

application/json

application/json

application/json

curl -X DELETE "https://api.godaddy.com/v1/agents/string/certificates/server/renewal"
Empty
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}

Verify ACME challenges for pending server cert renewal

POST
/v1/agents/{agentId}/certificates/server/renewal/verify-acme

Path Parameters

agentId*string

Unique identifier of the agent (UUID format)

Response Body

application/json

application/json

application/json

application/json

application/json

application/json

application/json

curl -X POST "https://api.godaddy.com/v1/agents/string/certificates/server/renewal/verify-acme"
{
  "status": "VERIFIED",
  "csrId": "3081018b-0577-442d-b092-6e1f08ef6e0d",
  "tlsaDnsRecord": {
    "name": "string",
    "priority": 0,
    "purpose": "DISCOVERY",
    "required": true,
    "ttl": 3600,
    "type": "HTTPS",
    "value": "string"
  },
  "nextStep": {
    "action": "CONFIGURE_DNS",
    "description": "string",
    "endpoint": "http://example.com"
  }
}
{
  "status": "VERIFIED",
  "csrId": "3081018b-0577-442d-b092-6e1f08ef6e0d",
  "tlsaDnsRecord": {
    "name": "string",
    "priority": 0,
    "purpose": "DISCOVERY",
    "required": true,
    "ttl": 3600,
    "type": "HTTPS",
    "value": "string"
  },
  "nextStep": {
    "action": "CONFIGURE_DNS",
    "description": "string",
    "endpoint": "http://example.com"
  }
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}

Get CSR status

GET
/v1/agents/{agentId}/csrs/{csrId}/status

Path Parameters

agentId*string

Unique identifier of the agent (UUID format)

csrId*string

Unique identifier of the CSR

Formatuuid

Response Body

application/json

application/json

application/json

application/json

application/json

application/json

curl -X GET "https://api.godaddy.com/v1/agents/string/csrs/497f6eca-6276-4993-bfeb-53cbbbba6f08/status"
{
  "csrId": "3081018b-0577-442d-b092-6e1f08ef6e0d",
  "failureReason": "string",
  "status": "PENDING",
  "submittedAt": "2019-08-24T14:15:22Z",
  "type": "SERVER",
  "updatedAt": "2019-08-24T14:15:22Z"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}
{
  "code": "string",
  "details": {
    "property1": {},
    "property2": {}
  },
  "message": "string",
  "status": "ERROR"
}

Last updated on

How is this guide?